<?php

/**
 * This is the model class for table "item".
 *
 * The followings are the available columns in table 'item':
 * @property string $itemid
 * @property string $accitemdisc
 * @property string $saletaxid
 * @property string $itemtype
 * @property string $purctaxid
 * @property string $itgrpid
 * @property string $crcid
 * @property string $itgrp2id
 * @property string $accprcv
 * @property string $acccost
 * @property string $vendorid
 * @property string $accinv
 * @property string $itgrp3id
 * @property string $accpret
 * @property string $accsale
 * @property string $accsret
 * @property string $accexp
 * @property string $modelid
 * @property string $brandid
 * @property string $barcode
 * @property string $itemdesc
 * @property boolean $usepid
 * @property boolean $ispidunique
 * @property boolean $useqtyx
 * @property boolean $useed
 * @property boolean $ispurc
 * @property boolean $isstock
 * @property boolean $ismfg
 * @property boolean $issale
 * @property boolean $isasm
 * @property string $partno
 * @property string $intchg
 * @property string $size
 * @property string $color
 * @property string $grade
 * @property string $unit1
 * @property string $unitx
 * @property string $convx
 * @property string $unit2
 * @property string $conv2
 * @property string $unit3
 * @property string $conv3
 * @property string $unitdesc
 * @property string $purcunit
 * @property string $stockunit
 * @property string $saleunit
 * @property string $costmtd
 * @property string $vitemid
 * @property string $purcqtymin
 * @property integer $leadtime
 * @property string $qtymin
 * @property string $qtymax
 * @property string $qtyreorder
 * @property string $qtypo
 * @property string $qtyso
 * @property string $qtywip
 * @property string $itemnote
 * @property boolean $active
 * @property boolean $_xt
 * @property boolean $pousepid
 * @property boolean $sousepid
 * @property string $acccret
 * @property string $itemdesc2
 *
 * The followings are the available model relations:
 * @property Bnsd[] $bnsds
 * @property Bomd[] $bomds
 * @property Bnst[] $bnsts
 * @property Bomp[] $bomps
 * @property Bns[] $bns
 * @property Bom[] $boms
 * @property Cretd[] $cretds
 * @property Cost[] $costs
 * @property Consbns[] $consbns
 * @property Consd[] $consds
 * @property Delid[] $dels
 * @property Deobns[] $deobns
 * @property Delibns[] $delibns
 * @property Itemnote[] $itemnotes
 * @property Hostwod[] $hostwods
 * @property Jobcardm[] $jobcardms
 * @property Jobcardp[] $jobcardps
 * @property Kitchen[] $kitchens
 * @property Mfgpd[] $mfgpds
 * @property Mfgmd[] $mfgmds
 * @property Mfgmd[] $mfgmds1
 * @property Mfg[] $mfgs
 * @property Pprc[] $pprcs
 * @property Prc[] $prcs
 * @property Preqd[] $preqds
 * @property Pod[] $pods
 * @property Prcvd[] $prcvds
 * @property Pretd[] $pretds
 * @property Purcbns[] $purcbns
 * @property Qprc[] $qprcs
 * @property Purcd[] $purcds
 * @property Pretbns[] $pretbns
 * @property Sadjd[] $sadjds
 * @property Saled[] $saleds
 * @property Salebns[] $salebns
 * @property Sbs[] $sbs
 * @property Sretbns[] $sretbns
 * @property Stock[] $stocks
 * @property Sod[] $sods
 * @property Sretd[] $sretds
 * @property Stocklog[] $stocklogs
 * @property Stockbal[] $stockbals
 * @property Wcon[] $wcons
 * @property Deod[] $deods
 * @property Sttrd[] $sttrds
 * @property Stockad[] $stockads
 * @property Tax $purctax
 * @property Tax $saletax
 * @property Acc $accitemdisc0
 * @property Acc $accinv0
 * @property Bp $vendor
 * @property Brand $brand
 * @property Crc $crc
 * @property Itemtype $itemtype0
 * @property Itgrp $itgrp
 * @property Itgrp2 $itgrp2
 * @property Itgrp3 $itgrp3
 * @property Model $model
 * @property Acc $accsale0
 * @property Acc $acccost0
 * @property Acc $accexp0
 * @property Acc $accprcv0
 * @property Acc $accsret0
 * @property Wod[] $wods
 */
class Item extends CActiveRecord {

    /**
     * Returns the static model of the specified AR class.
     * @param string $className active record class name.
     * @return Item the static model class
     */
    public static function model($className=__CLASS__) {
        return parent::model($className);
    }

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return 'item';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('itemid', 'required'),
            array('leadtime', 'numerical', 'integerOnly' => true),
            array('itemid, partno, intchg', 'length', 'max' => 20),
            array('accitemdisc, itgrpid, itgrp2id, accprcv, acccost, accinv, itgrp3id, accpret, accsale, accsret, accexp, modelid, brandid, size, color, acccret', 'length', 'max' => 10),
            array('saletaxid, itemtype, purctaxid, crcid, grade, unit1, unitx, unit2, unit3, purcunit, stockunit, saleunit', 'length', 'max' => 5),
            array('vendorid, convx, conv2, conv3, vitemid, purcqtymin, qtymin, qtymax, qtyreorder, qtypo, qtyso, qtywip', 'length', 'max' => 15),
            array('barcode', 'length', 'max' => 100),
            array('itemdesc', 'length', 'max' => 50),
            array('unitdesc', 'length', 'max' => 25),
            array('costmtd', 'length', 'max' => 4),
            array('usepid, ispidunique, useqtyx, useed, ispurc, isstock, ismfg, issale, isasm, itemnote, active, _xt, pousepid, sousepid, itemdesc2', 'safe'),
            // The following rule is used by search().
            // Please remove those attributes that should not be searched.
            array('itemid, accitemdisc, saletaxid, itemtype, purctaxid, itgrpid, crcid, itgrp2id, accprcv, acccost, vendorid, accinv, itgrp3id, accpret, accsale, accsret, accexp, modelid, brandid, barcode, itemdesc, usepid, ispidunique, useqtyx, useed, ispurc, isstock, ismfg, issale, isasm, partno, intchg, size, color, grade, unit1, unitx, convx, unit2, conv2, unit3, conv3, unitdesc, purcunit, stockunit, saleunit, costmtd, vitemid, purcqtymin, leadtime, qtymin, qtymax, qtyreorder, qtypo, qtyso, qtywip, itemnote, active, _xt, pousepid, sousepid, acccret, itemdesc2', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
            'bnsds' => array(self::HAS_MANY, 'Bnsd', 'itemid'),
            'bomds' => array(self::HAS_MANY, 'Bomd', 'itemid'),
            'bnsts' => array(self::HAS_MANY, 'Bnst', 'itemid'),
            'bomps' => array(self::HAS_MANY, 'Bomp', 'itemid'),
            'bns' => array(self::HAS_MANY, 'Bns', 'itemid'),
            'boms' => array(self::HAS_MANY, 'Bom', 'itemid'),
            'cretds' => array(self::HAS_MANY, 'Cretd', 'itemid'),
            'costs' => array(self::HAS_MANY, 'Cost', 'itemid'),
            'consbns' => array(self::HAS_MANY, 'Consbns', 'itemid'),
            'consds' => array(self::HAS_MANY, 'Consd', 'itemid'),
            'dels' => array(self::HAS_MANY, 'Delid', 'itemid'),
            'deobns' => array(self::HAS_MANY, 'Deobns', 'itemid'),
            'delibns' => array(self::HAS_MANY, 'Delibns', 'itemid'),
            'itemnotes' => array(self::HAS_MANY, 'Itemnote', 'itemid'),
            'hostwods' => array(self::HAS_MANY, 'Hostwod', 'itemid'),
            'jobcardms' => array(self::HAS_MANY, 'Jobcardm', 'itemid'),
            'jobcardps' => array(self::HAS_MANY, 'Jobcardp', 'itemid'),
            'kitchens' => array(self::MANY_MANY, 'Kitchen', 'itemkitchen(itemid, kitchenno)'),
            'mfgpds' => array(self::HAS_MANY, 'Mfgpd', 'itemid'),
            'mfgmds' => array(self::HAS_MANY, 'Mfgmd', 'itemid'),
            'mfgmds1' => array(self::HAS_MANY, 'Mfgmd', 'itemidsub'),
            'mfgs' => array(self::HAS_MANY, 'Mfg', 'itemid'),
            'pprcs' => array(self::HAS_MANY, 'Pprc', 'itemid'),
            'prcs' => array(self::HAS_MANY, 'Prc', 'itemid'),
            'preqds' => array(self::HAS_MANY, 'Preqd', 'itemid'),
            'pods' => array(self::HAS_MANY, 'Pod', 'itemid'),
            'prcvds' => array(self::HAS_MANY, 'Prcvd', 'itemid'),
            'pretds' => array(self::HAS_MANY, 'Pretd', 'itemid'),
            'purcbns' => array(self::HAS_MANY, 'Purcbns', 'itemid'),
            'qprcs' => array(self::HAS_MANY, 'Qprc', 'itemid'),
            'purcds' => array(self::HAS_MANY, 'Purcd', 'itemid'),
            'pretbns' => array(self::HAS_MANY, 'Pretbns', 'itemid'),
            'sadjds' => array(self::HAS_MANY, 'Sadjd', 'itemid'),
            'saleds' => array(self::HAS_MANY, 'Saled', 'itemid'),
            'salebns' => array(self::HAS_MANY, 'Salebns', 'itemid'),
            'sbs' => array(self::HAS_MANY, 'Sbs', 'itemid'),
            'sretbns' => array(self::HAS_MANY, 'Sretbns', 'itemid'),
            'stocks' => array(self::HAS_MANY, 'Stock', 'itemid'),
            'sods' => array(self::HAS_MANY, 'Sod', 'itemid'),
            'sretds' => array(self::HAS_MANY, 'Sretd', 'itemid'),
            'stocklogs' => array(self::HAS_MANY, 'Stocklog', 'itemid'),
            'stockbals' => array(self::HAS_MANY, 'Stockbal', 'itemid'),
            'wcons' => array(self::HAS_MANY, 'Wcon', 'itemid'),
            'deods' => array(self::HAS_MANY, 'Deod', 'itemid'),
            'sttrds' => array(self::HAS_MANY, 'Sttrd', 'itemid'),
            'stockads' => array(self::HAS_MANY, 'Stockad', 'itemid'),
            'purctax' => array(self::BELONGS_TO, 'Tax', 'purctaxid'),
            'saletax' => array(self::BELONGS_TO, 'Tax', 'saletaxid'),
            'accitemdisc0' => array(self::BELONGS_TO, 'Acc', 'accitemdisc'),
            'accinv0' => array(self::BELONGS_TO, 'Acc', 'accinv'),
            'vendor' => array(self::BELONGS_TO, 'Bp', 'vendorid'),
            'brand' => array(self::BELONGS_TO, 'Brand', 'brandid'),
            'crc' => array(self::BELONGS_TO, 'Crc', 'crcid'),
            'itemtype0' => array(self::BELONGS_TO, 'Itemtype', 'itemtype'),
            'itgrp' => array(self::BELONGS_TO, 'Itgrp', 'itgrpid'),
            'itgrp2' => array(self::BELONGS_TO, 'Itgrp2', 'itgrp2id'),
            'itgrp3' => array(self::BELONGS_TO, 'Itgrp3', 'itgrp3id'),
            'model' => array(self::BELONGS_TO, 'Model', 'modelid'),
            'accsale0' => array(self::BELONGS_TO, 'Acc', 'accsale'),
            'acccost0' => array(self::BELONGS_TO, 'Acc', 'acccost'),
            'accexp0' => array(self::BELONGS_TO, 'Acc', 'accexp'),
            'accprcv0' => array(self::BELONGS_TO, 'Acc', 'accprcv'),
            'accsret0' => array(self::BELONGS_TO, 'Acc', 'accsret'),
            'wods' => array(self::HAS_MANY, 'Wod', 'itemid'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'itemid' => Yii::t('item', 'itemid'),
            'accitemdisc' => Yii::t('item', 'accitemdisc'),
            'saletaxid' => Yii::t('item', 'saletaxid'),
            'itemtype' => Yii::t('item', 'itemtype'),
            'purctaxid' => Yii::t('item', 'purctaxid'),
            'itgrpid' => Yii::t('item', 'itgrpid'),
            'crcid' => Yii::t('item', 'crcid'),
            'itgrp2id' => Yii::t('item', 'itgrp2id'),
            'accprcv' => Yii::t('item', 'accprcv'),
            'acccost' => Yii::t('item', 'acccost'),
            'vendorid' => Yii::t('item', 'vendorid'),
            'accinv' => Yii::t('item', 'accinv'),
            'itgrp3id' => Yii::t('item', 'itgrp3id'),
            'accpret' => Yii::t('item', 'accpret'),
            'accsale' => Yii::t('item', 'accsale'),
            'accsret' => Yii::t('item', 'accsret'),
            'accexp' => Yii::t('item', 'accexp'),
            'modelid' => Yii::t('item', 'modelid'),
            'brandid' => Yii::t('item', 'brandid'),
            'barcode' => Yii::t('item', 'barcode'),
            'itemdesc' => Yii::t('item', 'itemdesc'),
            'usepid' => Yii::t('item', 'usepid'),
            'ispidunique' => Yii::t('item', 'ispidunique'),
            'useqtyx' => Yii::t('item', 'useqtyx'),
            'useed' => Yii::t('item', 'useed'),
            'ispurc' => Yii::t('item', 'ispurc'),
            'isstock' => Yii::t('item', 'isstock'),
            'ismfg' => Yii::t('item', 'ismfg'),
            'issale' => Yii::t('item', 'issale'),
            'isasm' => Yii::t('item', 'isasm'),
            'partno' => Yii::t('item', 'partno'),
            'intchg' => Yii::t('item', 'intchg'),
            'size' => Yii::t('item', 'size'),
            'color' => Yii::t('item', 'color'),
            'grade' => Yii::t('item', 'grade'),
            'unit1' => Yii::t('item', 'unit1'),
            'unitx' => Yii::t('item', 'unitx'),
            'convx' => Yii::t('item', 'convx'),
            'unit2' => Yii::t('item', 'unit2'),
            'conv2' => Yii::t('item', 'conv2'),
            'unit3' => Yii::t('item', 'unit3'),
            'conv3' => Yii::t('item', 'conv3'),
            'unitdesc' => Yii::t('item', 'unitdesc'),
            'purcunit' => Yii::t('item', 'purcunit'),
            'stockunit' => Yii::t('item', 'stockunit'),
            'saleunit' => Yii::t('item', 'saleunit'),
            'costmtd' => Yii::t('item', 'costmtd'),
            'vitemid' => Yii::t('item', 'vitemid'),
            'purcqtymin' => Yii::t('item', 'purcqtymin'),
            'leadtime' => Yii::t('item', 'leadtime'),
            'qtymin' => Yii::t('item', 'qtymin'),
            'qtymax' => Yii::t('item', 'qtymax'),
            'qtyreorder' => Yii::t('item', 'qtyreorder'),
            'qtypo' => Yii::t('item', 'qtypo'),
            'qtyso' => Yii::t('item', 'qtyso'),
            'qtywip' => Yii::t('item', 'qtywip'),
            'itemnote' => Yii::t('item', 'itemnote'),
            'active' => Yii::t('item', 'active'),
            '_xt' => Yii::t('item', '_xt'),
            'pousepid' => Yii::t('item', 'pousepid'),
            'sousepid' => Yii::t('item', 'sousepid'),
            'acccret' => Yii::t('item', 'acccret'),
            'itemdesc2' => Yii::t('item', 'itemdesc2'),
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
     */
    public function search() {
        // Warning: Please modify the following code to remove attributes that
        // should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('itemid', $this->itemid, true);
        $criteria->compare('accitemdisc', $this->accitemdisc, true);
        $criteria->compare('saletaxid', $this->saletaxid, true);
        $criteria->compare('itemtype', $this->itemtype, true);
        $criteria->compare('purctaxid', $this->purctaxid, true);
        $criteria->compare('itgrpid', $this->itgrpid, true);
        $criteria->compare('crcid', $this->crcid, true);
        $criteria->compare('itgrp2id', $this->itgrp2id, true);
        $criteria->compare('accprcv', $this->accprcv, true);
        $criteria->compare('acccost', $this->acccost, true);
        $criteria->compare('vendorid', $this->vendorid, true);
        $criteria->compare('accinv', $this->accinv, true);
        $criteria->compare('itgrp3id', $this->itgrp3id, true);
        $criteria->compare('accpret', $this->accpret, true);
        $criteria->compare('accsale', $this->accsale, true);
        $criteria->compare('accsret', $this->accsret, true);
        $criteria->compare('accexp', $this->accexp, true);
        $criteria->compare('modelid', $this->modelid, true);
        $criteria->compare('brandid', $this->brandid, true);
        $criteria->compare('barcode', $this->barcode, true);
        $criteria->compare('itemdesc', $this->itemdesc, true);
        $criteria->compare('usepid', $this->usepid);
        $criteria->compare('ispidunique', $this->ispidunique);
        $criteria->compare('useqtyx', $this->useqtyx);
        $criteria->compare('useed', $this->useed);
        $criteria->compare('ispurc', $this->ispurc);
        $criteria->compare('isstock', $this->isstock);
        $criteria->compare('ismfg', $this->ismfg);
        $criteria->compare('issale', $this->issale);
        $criteria->compare('isasm', $this->isasm);
        $criteria->compare('partno', $this->partno, true);
        $criteria->compare('intchg', $this->intchg, true);
        $criteria->compare('size', $this->size, true);
        $criteria->compare('color', $this->color, true);
        $criteria->compare('grade', $this->grade, true);
        $criteria->compare('unit1', $this->unit1, true);
        $criteria->compare('unitx', $this->unitx, true);
        $criteria->compare('convx', $this->convx, true);
        $criteria->compare('unit2', $this->unit2, true);
        $criteria->compare('conv2', $this->conv2, true);
        $criteria->compare('unit3', $this->unit3, true);
        $criteria->compare('conv3', $this->conv3, true);
        $criteria->compare('unitdesc', $this->unitdesc, true);
        $criteria->compare('purcunit', $this->purcunit, true);
        $criteria->compare('stockunit', $this->stockunit, true);
        $criteria->compare('saleunit', $this->saleunit, true);
        $criteria->compare('costmtd', $this->costmtd, true);
        $criteria->compare('vitemid', $this->vitemid, true);
        $criteria->compare('purcqtymin', $this->purcqtymin, true);
        $criteria->compare('leadtime', $this->leadtime);
        $criteria->compare('qtymin', $this->qtymin, true);
        $criteria->compare('qtymax', $this->qtymax, true);
        $criteria->compare('qtyreorder', $this->qtyreorder, true);
        $criteria->compare('qtypo', $this->qtypo, true);
        $criteria->compare('qtyso', $this->qtyso, true);
        $criteria->compare('qtywip', $this->qtywip, true);
        $criteria->compare('itemnote', $this->itemnote, true);
        $criteria->compare('active', $this->active);
        $criteria->compare('_xt', $this->_xt);
        $criteria->compare('pousepid', $this->pousepid);
        $criteria->compare('sousepid', $this->sousepid);
        $criteria->compare('acccret', $this->acccret, true);
        $criteria->compare('itemdesc2', $this->itemdesc2, true);

        return new CActiveDataProvider($this, array(
                    'criteria' => $criteria,
                ));
    }

    public function getPurcTaxId($itemid) {
        $model = self::model()->findByPk($itemid);
        if ($model != null) {
            return $model->purctaxid;
        } else {
            return null;
        }
    }
    
    public function getSaleTaxId($itemid) {
        $model = self::model()->findByPk($itemid);
        if ($model != null) {
            return $model->saletaxid;
        } else {
            return null;
        }
    }

}