<?php

/**
 * This is the model class for table "prc".
 *
 * The followings are the available columns in table 'prc':
 * @property string $itemid
 * @property string $prclvlid
 * @property string $crcid
 * @property string $price1
 * @property string $profit1exp
 * @property string $disc1exp
 * @property string $price1nett
 * @property string $price2
 * @property string $profit2exp
 * @property string $disc2exp
 * @property string $price2nett
 * @property string $price3
 * @property string $profit3exp
 * @property string $disc3exp
 * @property string $price3nett
 * @property string $pricedate
 * @property string $usrid
 * @property string $lastpurcprice
 * @property string $lastavgcost
 *
 * The followings are the available model relations:
 * @property Crc $crc
 * @property Item $item
 * @property Prclvl $prclvl
 * @property Usr $usr
 */
class Prc extends CActiveRecord {

    /**
     * Returns the static model of the specified AR class.
     * @param string $className active record class name.
     * @return Prc the static model class
     */
    public static function model($className=__CLASS__) {
        return parent::model($className);
    }

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return 'prc';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('itemid, prclvlid, crcid', 'required'),
            array('itemid', 'length', 'max' => 20),
            array('prclvlid', 'length', 'max' => 3),
            array('crcid', 'length', 'max' => 5),
            array('price1, price1nett, price2, price2nett, price3, price3nett, lastpurcprice, lastavgcost', 'length', 'max' => 19),
            array('profit1exp, disc1exp, profit2exp, disc2exp, profit3exp, disc3exp', 'length', 'max' => 15),
            array('usrid', 'length', 'max' => 10),
            array('pricedate', 'safe'),
            // The following rule is used by search().
            // Please remove those attributes that should not be searched.
            array('itemid, prclvlid, crcid, price1, profit1exp, disc1exp, price1nett, price2, profit2exp, disc2exp, price2nett, price3, profit3exp, disc3exp, price3nett, pricedate, usrid, lastpurcprice, lastavgcost', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
            'crc' => array(self::BELONGS_TO, 'Crc', 'crcid'),
            'item' => array(self::BELONGS_TO, 'Item', 'itemid'),
            'prclvl' => array(self::BELONGS_TO, 'Prclvl', 'prclvlid'),
            'usr' => array(self::BELONGS_TO, 'Usr', 'usrid'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'itemid' => Yii::t('prc', 'itemid'),
            'prclvlid' => Yii::t('prc', 'prclvlid'),
            'crcid' => Yii::t('prc', 'crcid'),
            'price1' => Yii::t('prc', 'price1'),
            'profit1exp' => Yii::t('prc', 'profit1exp'),
            'disc1exp' => Yii::t('prc', 'disc1exp'),
            'price1nett' => Yii::t('prc', 'price1nett'),
            'price2' => Yii::t('prc', 'price2'),
            'profit2exp' => Yii::t('prc', 'profit2exp'),
            'disc2exp' => Yii::t('prc', 'disc2exp'),
            'price2nett' => Yii::t('prc', 'price2nett'),
            'price3' => Yii::t('prc', 'price3'),
            'profit3exp' => Yii::t('prc', 'profit3exp'),
            'disc3exp' => Yii::t('prc', 'disc3exp'),
            'price3nett' => Yii::t('prc', 'price3nett'),
            'pricedate' => Yii::t('prc', 'pricedate'),
            'usrid' => Yii::t('prc', 'usrid'),
            'lastpurcprice' => Yii::t('prc', 'lastpurcprice'),
            'lastavgcost' => Yii::t('prc', 'lastavgcost'),
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
     */
    public function search() {
        // Warning: Please modify the following code to remove attributes that
        // should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('itemid', $this->itemid, true);
        $criteria->compare('prclvlid', $this->prclvlid, true);
        $criteria->compare('crcid', $this->crcid, true);
        $criteria->compare('price1', $this->price1, true);
        $criteria->compare('profit1exp', $this->profit1exp, true);
        $criteria->compare('disc1exp', $this->disc1exp, true);
        $criteria->compare('price1nett', $this->price1nett, true);
        $criteria->compare('price2', $this->price2, true);
        $criteria->compare('profit2exp', $this->profit2exp, true);
        $criteria->compare('disc2exp', $this->disc2exp, true);
        $criteria->compare('price2nett', $this->price2nett, true);
        $criteria->compare('price3', $this->price3, true);
        $criteria->compare('profit3exp', $this->profit3exp, true);
        $criteria->compare('disc3exp', $this->disc3exp, true);
        $criteria->compare('price3nett', $this->price3nett, true);
        $criteria->compare('pricedate', $this->pricedate, true);
        $criteria->compare('usrid', $this->usrid, true);
        $criteria->compare('lastpurcprice', $this->lastpurcprice, true);
        $criteria->compare('lastavgcost', $this->lastavgcost, true);

        return new CActiveDataProvider($this, array(
                    'criteria' => $criteria,
                ));
    }

    public function getPrice1($itemid, $prclvlid, $crcid) {
        $model = self::model()->findByAttributes(array('itemid' => $itemid, 'prclvlid' => $prclvlid, 'crcid' => $crcid));
        if ($model != null) {
            return $model->price1;
        } else {
            return null;
        }
    }
    
    public function getDiscPromo($itemid, $qty, $unit, $saledate, $bpid, $total=0, $bpgrpid='null') {
        $disc = null;
        
        $command = Yii::app()->db->createCommand("SELECT * FROM fprcpromo(:itemid, :qty, :unit, :saledate, :bpid, :total, :bpgrpid)");

        /* set parameter value */
        $command->bindValue(':itemid', $itemid);
        $command->bindValue(':qty', $qty);
        $command->bindValue(':unit', $unit);
        $command->bindValue(':saledate', $saledate);
        $command->bindValue(':bpid', $bpid);
        $command->bindValue(':total', $total);
        $command->bindValue(':bpgrpid', $bpgrpid);
        
        $result = $command->queryRow();
        $disc = $result['discexp'];

        return $disc;
    }

}